﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.2
@EndOfDesignText@
Sub Class_Globals
	Dim xui As XUI
	
	Public mView As B4XView
	Public mParent As Activity
	Public mEventName As String
	Public mIndex As Int
		
	Public isVisible As Boolean = False
	
	Private sText As String = ""
	Private sTitle As String = ""
	Private sIcon As String = ""
	
	Private pBgColor As Int
	Private oTitleColor As Int
	Private oMessageColor As Int
	Private oIconColor As Int
	Private oPosition As Int = 0
	
	Private lblIcon As Label
	Private lblContent As Label
	Private lblTitle As Label
	Private lblClose As Label
	Private pnlBackground As Panel
	
	Public H_TOP As Int = 0
	Public H_CENTER As Int = 1
	Public H_BOTTOM As Int = 2
	
	Private tmr As Timer
	Private StartTime As Long
	Public Duration As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Activity, EventName As String)

	'Save the variables:
	mParent = Parent
	mEventName = EventName
	mView = xui.CreatePanel(mEventName)
	mView.LoadLayout("layout_PopUp")
	
End Sub

Public Sub Show
	Dim pos As Float = 0
	
	Select oPosition
		Case 0: pos = 0
		Case 1: pos = 35%y
		Case 2: pos = 85%y
	End Select
	
	
	mView.SetVisibleAnimated(700, True)
	mView.SetLayoutAnimated(700,0,0,(mParent.Width*85%x),110dip)
	mView.Tag = mEventName
	
	If isVisible = False Then mParent.AddView(mView,0,pos,(mParent.Width*85%x),110dip)
	
	lblContent.Text = sText
	lblContent.TextColor = oMessageColor
	lblTitle.Text = sTitle
	lblTitle.TextColor = oTitleColor
	pnlBackground.Color = pBgColor
	lblIcon.Text = sIcon
	lblIcon.TextColor = oIconColor
	isVisible = True
	StartTime = DateTime.Now
	tmr.Initialize("tmr",1000)
	
	If Not(Duration = 0) Then tmr.Enabled = True
End Sub

Public Sub Hide
	mView.SetVisibleAnimated(300, False)
	isVisible = False
End Sub

Private Sub lblClose_Click
	Hide
End Sub

Private Sub tmr_Tick
	
	Dim S As Int = ConvertMillisecondsToSeconds(DateTime.Now - StartTime)
	
	If S = Duration Then
		Hide
	End If
End Sub

Private Sub ConvertMillisecondsToSeconds(t As Long) As Int
	Dim Seconds As Int
	Seconds = (t Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond
	Return Seconds
End Sub

#Region ////////////////////////Methods///////////////////////////
Public Sub setBackColor(Color As Int)
	pBgColor = Color
End Sub
Public Sub getBackColor As Int
	Return pBgColor
End Sub

Public Sub setTitleColor(Color As Object)
	oTitleColor = Color
End Sub
Public Sub getTitleColor As Object
	Return oTitleColor
End Sub

Public Sub setMessageColor(Color As Object)
	oMessageColor = Color
End Sub
Public Sub getMessageColor As Object
	Return oMessageColor
End Sub

Public Sub View As B4XView
	Return mView
End Sub

Public Sub setMessage(Text As String)
	sText = Text
End Sub
Public Sub getMessage As String
	Return sText
End Sub

Public Sub setTitle(Title As String)
	sTitle = Title
End Sub
Public Sub getTitle As String
	Return sTitle
End Sub

Public Sub setIcon(Icon As String)
	sIcon = Icon
End Sub

Public Sub setIconColor(Color As Int)
	oIconColor = Color
End Sub

Public Sub setPosition(Position As Int)
	oPosition = Position
End Sub


#End Region
